xbasc()
write(%io(2),'lissage d''une fonction par transforme de Fourier ([DaLi], page 835) ');
ep1=evstr(x_dialog('taux de lissage methode 1 (perturbation)','0.02'));
ep2=evstr(x_dialog('taux de lissage methode 2 (convolution)','0.1'));
n=evstr(x_dialog('Entrez n (nombre de termes=2^n) pour le lissage','7'));
N=2^n;
//
//------------------------------------------------------------------
//
// signal  lisser
//
deff('y=f(x)','y=exp(-100*(x-(1/5))^2)+exp(-500*(x-(2/5))^2)+...
	exp(-2500*(x-(3/5))^2)+exp(-12500*(x-(4/5))^2)');
x=(0:N-1)/(N-1);
u=(f(x)+0.1*rand(x,'n'));
//
//------------------------------------------------------------------
//
// lissage du signal par FFT
//
x=x';u=u';
U4=fft(u,-1);
//
// methode 1: perturbation
//
U5=U4;
U5(2:N/2+1)=U4(2:N/2+1)./(1+ep1.*(1:N/2)'.^2);
U5(N/2+1:N)=U4(N/2+1:N)./(1+ep1.*(N/2:-1:1)'.^2);
u5=abs(fft(U5,1));
//
// methode 2: convolution
//
U6=U4;
U6(2:N/2+1)=U4(2:N/2+1).*exp(-ep2^2.*(1:N/2)'.^2);
U6(N/2+1:N)=U4(N/2+1:N).*exp(-ep2^2.*(N/2:-1:1)'.^2);
u6=abs(fft(U6,1));
leg='fonction initiale@regularisee par perturbation@regularisee par convolution';
plot2d([x,x,x],[u,u5,u6],[1,2,3],'121',leg);
xtitle('lissage d''une fonction par FFT')
//

