write(%io(2),'algorithmes de calcul d''une transformee de Fourier discrete');
//
n=evstr(x_dialog('Entrez n (nombre de termes=2^n) pour le calcul','7'));
N=2^n;
//
//------------------------------------------------------------------
//
// fft  calculer
//
u=rand(1,N);
//
w=exp(-2*%i*%pi/N);
//
//------------------------------------------------------------------
//
//  calcul de la TFD
//
// transformee de Fourier discrete
//
timer();
//F=zeros(N,N);
//for i=1:N
//   for j=1:N
//      F(i,j)=w^((i-1)*(j-1));
//   end;
//end;
//U1=u*F;
//
// transformee de Fourier rapide 
// algorithme 1 (avec fonction rcursive)
//
//
b=timer();
P=zeros(1,N/2);
for i=1:(N/2)
   P(i)=w^(i-1);
   end;
U2=u;
I_pai=1:2:N;
I_imp=2:2:N;
i_inf=1:(N/2);
i_sup=(N/2+1):N;
U2(I_pai)=TraFouRap(u(i_inf)+u(i_sup),n-1);
U2(I_imp)=TraFouRap(P.*(u(i_inf)-u(i_sup)),n-1);
U7=TraFouRap(u,n);
//
// transformee de Fourier rapide 
// algorithme 2 (non rcursif)
//
//
c=timer();
U3=u;
for p=n:-1:1
  for k=1:(2^n/2^p)
    U3(((k-1)*2^p+1):k*2^p)=etape(p,U3(((k-1)*2^p+1):k*2^p));
  end
end
U3=permut(U3,n);
//
// transformee de Fourier rapide 
// algorithme Scilab
//  
//
d=timer();
U4=fft(u,-1);
e=timer();
//d2=timer();
//UUU=dft(u,-1);
//e2=timer();
//
write(%io(2),'comparaison des erreurs et des temps de calcul pour 4 methodes:');
write(%io(2),'methode 1: transforme de Fourier discrte');
write(%io(2),'methode 2: algorithme rcursif de fft');
write(%io(2),'methode 3: algorithme non rcursif de fft');
write(%io(2),'methode 4 (rfrence): algorithme fft de Scilab');//
disp('erreur respectives par rapport a fft de Scilab:')
disp(max(abs(U1-U4)));disp(max(abs(U2-U4)));disp(max(abs(U3-U4)));
disp('temps de calcul respectifs:');
disp(b);disp(c);disp(d);disp(e);