xbasc()
//calcul de l'integrale d'une fonction f 
//entre a et b par la mthode des trapzes (val3)
//et par la methode de Monte Carlo (val4)
//precision epsilon fixee
//on augmente n de 50 jusqu'a obtenir la precision souhaitee
//comparaison avec la valeur donnee par la  
// fonction integrate (val1) et avec la valeur exacte (val2)
write(%io(2),'precision souhaitee') 
[epsilon]=read(%io(1),1,1);
// 
//choix de la fonction 
a=0; 
b=1; 
deff('y=f(x)','y=sin(x)-x') 
//valeur approchee 
val1=integrate('sin(x)-x','x',a,b); 
//valeur exacte 
val2=-cos(b)-(b^2)/2+cos(a)+(a^2)/2; 
//trapezes 
p=0;n=1;
val3a=0;val3=(f(a)+f(b))/2*(b-a);A3=[];A4=[];R=[val3];
write(%io(2),'  trapezes: ') 
while (abs(val3-val2)>epsilon)&(n<2000) 
p=p+1; 
n=2^p;
h=(b-a)/n; 
for i=1:2:n-1
  val3a=val3a+f(a+i*h); 
end 
val3=(val3a+(f(a)+f(b))/2)*h;
R=[R;val3];
//
// methode de Romberg
//
R1=R;
for i=1:p
  for j=p:-1:i
    R1(j+1)=(4^i*R1(j+1)-R1(j))/(4^i-1);
  end
end
//
write (%io(2),[n,abs(val3-val2),abs(R1(p)-val2)],'(f6.0,1x,e14.6,1x,e14.6)')  
A3=[A3;n];A4=[A4;abs(val3-val2)];
end 
// Monte Carlo (probabilite '1.96sigma'=95%) 
n=0;
xint=0; xint2=0;xerr4=1E5;A1=[];A2a=[];A2b=[];
write(%io(2),'  Monte Carlo: ') 
while (abs(xerr4)>epsilon)&(n<2000)
n0=n;
n=100+n; 
for i=n0:n
  xb=a+(b-a)*rand();
  xint=xint+f(xb); 
  xint2=xint2+f(xb)^2;
end 
val4=xint/n; 
xvar4=sqrt(xint2/n-val4^2);
xerr4=1.96*xvar4/sqrt(n);
write (%io(2),[n,xerr4,val4-val2],'(f6.0,1x,2(e14.6))')  
A1=[A1;n];A2a=[A2a;xerr4];A2b=[A2b;abs(val4-val2)];
end
plot2d1('gll',[A1,A1],[A2a,A2b],[1,2],'151','erreur MC a 96%@erreur MC calculee',[1E-10,epsilon,max(A1),max(A2a)]);
plot2d1('gll',A3,A4,3,'100','erreur trapezes');
xtitle('calcul approche de l integrale de sin(x)-x entre 0 et 1')
 
